# fakeroot

Чистая реализация fakeroot на Go с использованием пространств имен пользователей Linux.
a
### Что такое fakeroot?

Fakeroot — это утилита, которая запускает команды в среде, где они кажутся имеющими права суперпользователя, хотя на самом деле это не так. [Оригинальная команда](https://salsa.debian.org/clint/fakeroot/) fakeroot делает это, перехватывая вызовы функций библиотеки libc, таких как `stat()`, `chmod()`, `chown()` и т. д., и заменяя их на функции, которые возвращают значения, делающие видимым, что пользователь является суперпользователем.

### Чем эта библиотека отличается?

Вместо внедрения собственных функций libc эта библиотека использует встроенные функции изоляции ядра Linux, чтобы создать своего рода контейнер, где пользователь является суперпользователем. Это означает, что даже программы, не использующие libc (такие как программы на Go), или программы с статически связанной libc, будут думать, что они работают от имени root.

Вы также можете вложить этот тип fakeroot до 32 раз, в отличие от оригинального варианта на основе libc, который совсем не поддерживает вложение.

Однако этот подход будет работать только на достаточно новых ядрах Linux (3.8+) и на дистрибутивах, которые не отключают эту функциональность. Тем не менее, большинство современных систем Linux поддерживают это, так что в большинстве случаев это должно работать.

### Почему?

Многие утилиты зависят от прав доступа к файлам и принадлежности пользователей. Например, команда tar создает файлы в архиве tar с теми же правами, что и у оригинальных файлов. Это означает, что если файлы принадлежали конкретному пользователю, они сохранят эту принадлежность при извлечении архива tar. Это может стать проблемой при создании пакетов, поскольку это может привести к тому, что системные файлы в пакете будут принадлежать пользователям, не являющимся суперпользователями. Создавая иллюзию, что текущий пользователь является суперпользователем и поэтому все файлы принадлежат root, fakeroot обманывает утилиты, такие как tar, заставляя их создавать свои файлы с правами root.

Кроме того, многие утилиты могут требовать права суперпользователя для определенных операций, но могут возвращать ошибки, даже если конкретная задача не требует этих повышенных прав. Fakeroot можно использовать для выполнения этих программ, не предоставляя им реально права суперпользователя, что обеспечивает дополнительную безопасность.

### nsfakeroot

Этот репозиторий включает утилиту командной строки под названием `nsfakeroot`. Чтобы установить его, выполните следующую команду:

```sh
go install gitea.plemya-x.ru/Plemya-x/fakeroot/cmd/nsfakeroot@latest
```

Запуск `nsfakeroot` самостоятельно начнет вашу оболочку входа в среде fakeroot. Если вы предоставите аргументы, они будут использоваться как команда.

Примеры:

```sh
nsfakeroot        # -> (login shell)
nsfakeroot whoami # -> root
nsfakeroot id -u  # -> 0
nsfakeroot id -g  # -> 0
```